<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class ProductRequest extends FormRequest
{

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('products'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'image'=>'required',
            'children'=>'required|numeric',
            'adult'=>'required|numeric',
            'category_id'=>'required|exists:categories,id',
            'features.*.image'=>'required',
        ];

        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required',
                'description_'.$lang->local=> 'required',
                'features.*.feature_'.$lang->local=>'required',
                'features.*.details.*.detail_'.$lang->local=>'required',
            ];
            $rules= array_merge($rules, $lang_rules);
        }
        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $field = metaFields('products');
        $attributes=[
            'image' => __('products.image'),
            'category_id' => __('products.category_id'),
            'children' => __('products.children'),
            'adult' => __('products.adult'),
            'features' => __('products.adult'),
        ];

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local=>  __('products.name') .' '.$lang->local,
                'description_'.$lang->local=>  __('products.description') .' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }


        $features = request('features');
        if($features)
        {
            foreach ($features as $key => $value)
            {
                $serial = ($key + 1);
                $lang_attributes = [];
                $attributes['features.'.$key.'.image'] = __('products.image_feature') .' '. $serial;
                foreach (languages() as $lang)
                {
                    $lang_attributes=[
                        'features.'.$key.'.feature_'.$lang->local => __('products.feature').' '.$serial.' '.$lang->local,
                    ];
                    $attributes= array_merge($attributes, $lang_attributes);
                }
                if(isset($value['details']))
                {
                    foreach ($value['details'] as $keyDetails => $valueDetails)
                    {
                        $serialDetail = ($keyDetails + 1);

                        $attributes= array_merge($attributes, $lang_attributes);
                        foreach (languages() as $lang)
                        {
                            $lang_attributes=[
                                'features.'.$key.'.details.'.$keyDetails.'.detail_'.$lang->local => __('products.feature').' '.$serial.' '.__('products.detail').' '.$serialDetail.' '. $lang->local,
                            ];
                            $attributes= array_merge($attributes, $lang_attributes);
                        }
                    }
                }
            }
        }

        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
